package com.qcg.comp.sdk;

import java.util.List;

import javax.xml.bind.JAXBException;
import javax.xml.namespace.QName;
import javax.xml.ws.Service;
import javax.xml.ws.WebServiceFeature;
import javax.xml.ws.handler.Handler;

import com.qcg.comp.stubs.socks.NotAuthorizedFault;
import com.qcg.comp.stubs.socks.QCGComputingSocks;
import com.qcg.comp.stubs.socks.QCGComputingSocksPortType;
import com.qcg.core.sdk.QCGCoreService;
import com.qcg.core.sdk.security.AuthenticationModule;

public class QCGSocks extends QCGCoreService {

	protected QCGComputingSocksPortType port;

	public QCGSocks(String hostname, int port,
			AuthenticationModule transportLayer,
			AuthenticationModule messageLayer, boolean useWSA)
			throws JAXBException {
		super(hostname, port, transportLayer, messageLayer, useWSA);
		this.port = (QCGComputingSocksPortType) stubs;
	}

	public QCGSocks(String hostname, int port,
			AuthenticationModule transportLayer,
			AuthenticationModule messageLayer) throws JAXBException {
		super(hostname, port, transportLayer, messageLayer);
		this.port = (QCGComputingSocksPortType) stubs;
	}

	public QCGSocks(String hostname, int port, AuthenticationModule am)
			throws JAXBException {
		super(hostname, port, am);
		this.port = (QCGComputingSocksPortType) stubs;
	}

	public static final String QCG_SOCKS_NS = "http://schemas.qoscosgrid.org/comp/2011/04/socks";

	@Override
	protected List<Handler> getHandlersChain() {
		return null;
	}

	@Override
	protected Object getPort(Service service, WebServiceFeature... features) {
		return ((QCGComputingSocks) service).getQCGComputingSocks(features);
	}

	@Override
	protected Service getService() {
		return new QCGComputingSocks(
				QCGSocks.class.getResource("/schemas/qcg-comp-socks.wsdl"),
				new QName(QCG_SOCKS_NS, "QCGComputingSocks"));
	}

	public synchronized String getToken() throws NotAuthorizedFault {
		return port.getConnectionToken(null).getSecurityToken();
	}

}