package com.qcg.comp.sdk.exceptions;

import java.util.List;

import com.qcg.comp.sdk.exceptions.QCGCompException;

public class InvalidRequestMessageException extends QCGCompException {
	protected List<String> invalidElements;
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public InvalidRequestMessageException(Throwable ex) {
		super(ex.getMessage(), ex);
		
		if (ex instanceof com.qcg.comp.stubs.bes.factory.InvalidRequestMessageFault) {
			com.qcg.comp.stubs.bes.factory.InvalidRequestMessageFault f = (com.qcg.comp.stubs.bes.factory.InvalidRequestMessageFault)ex;
			invalidElements = f.getFaultInfo().getInvalidElement();
			setInfoMessage(f.getFaultInfo().getMessage(), f.getFaultInfo().getInvalidElement());
		} else if (ex instanceof com.qcg.comp.stubs.ares.InvalidRequestMessageFault) {
			com.qcg.comp.stubs.ares.InvalidRequestMessageFault f = (com.qcg.comp.stubs.ares.InvalidRequestMessageFault)ex;
			invalidElements = f.getFaultInfo().getInvalidElement();
			setInfoMessage(f.getFaultInfo().getMessage(), f.getFaultInfo().getInvalidElement());
		} else {
			throw new AssertionError(ex);
		}
	}
	
	public List<String> getInvalidElements(){
		return invalidElements;
	}
}
