package com.qcg.comp.sdk.exceptions;

import java.util.List;

import com.qcg.comp.sdk.exceptions.QCGCompException;

public class UnsupportedFeatureException extends QCGCompException {
	protected List<String> features;
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public UnsupportedFeatureException(Throwable ex) {
		super(ex.getMessage(), ex);
		
		if (ex instanceof com.qcg.comp.stubs.bes.factory.UnsupportedFeatureFault) {
			com.qcg.comp.stubs.bes.factory.UnsupportedFeatureFault f = (com.qcg.comp.stubs.bes.factory.UnsupportedFeatureFault)ex;
			features = f.getFaultInfo().getFeature();
			setInfoMessage(f.getFaultInfo().getFeature());
		} else if (ex instanceof com.qcg.comp.stubs.ares.UnsupportedFeatureFault) {
			com.qcg.comp.stubs.ares.UnsupportedFeatureFault f = (com.qcg.comp.stubs.ares.UnsupportedFeatureFault)ex;
			features = f.getFaultInfo().getFeature();
			setInfoMessage(f.getFaultInfo().getFeature());
		} else {
			throw new AssertionError(ex);
		}
	}
	
	public List<String> getFeatures(){
		return features;
	}
}
