package com.qcg.comp.tests;



import java.io.FileInputStream;

import junit.framework.TestCase;

import com.qcg.comp.sdk.QCGFactory;
import com.qcg.comp.sdk.jsdl.JSDL;
import com.qcg.comp.sdk.types.ActivityEndpointReference;
import com.qcg.comp.sdk.types.QCGActivityStatus;
import com.qcg.core.sdk.security.gsi.GSIAuthentication;

/**
 * Unit test for simple Job submission.
 */
public class QCGCompHTTPGExample 
    extends TestCase
{
	public static final String QCG_COMPUTING_HOST = "elder1.man.poznan.pl";
	public static final int QCG_COMPUTING_PORT = 19000;
	
	public void testSubmit() throws Exception {
		QCGFactory besFactory =  new QCGFactory(QCG_COMPUTING_HOST, QCG_COMPUTING_PORT, new GSIAuthentication(new FileInputStream("/tmp/x509up_u501"), "/C=PL/O=GRID/O=PSNC/CN=qcg/elder1.man.poznan.pl"), true);
		
		/* create an JSDL document */
		JSDL dateJSDL = new JSDL("SimpleJob");
		
		dateJSDL.setExecutable("/bin/sleep");
		dateJSDL.getArguments().add("8000");
		
		/* submit a job */
		ActivityEndpointReference jobEpr = besFactory.createActivity(dateJSDL);
		
		System.err.println("Activity ID: " + jobEpr.getActivityUUID());
		
		QCGActivityStatus status = null;
		/* wait for termination */
		while (!(status =besFactory.getActivityStatus(jobEpr)).isFinalState()) { 
			Thread.sleep(500);
			System.err.println("Status = " + status);
			besFactory =  new QCGFactory(QCG_COMPUTING_HOST, QCG_COMPUTING_PORT, new GSIAuthentication(new FileInputStream("/tmp/x509up_u501"), "/C=PL/O=GRID/O=PSNC/CN=qcg/elder1.man.poznan.pl"), true);
		}
		
		
		if (status.getBESStateName().equals(QCGActivityStatus.QCG_ACTIVITY_STATE_FINISHED)) {
			System.out.println("Job " + status.getActivityIdentifier() + " finished with exit status: " + status.getEndStatus().getExitStatus() );
		} else if (status.getBESStateName().equals(QCGActivityStatus.QCG_ACTIVITY_STATE_FAILED)){
			System.err.println("Job " + status.getActivityIdentifier() + " failed");
		} else if (status.getBESStateName().equals(QCGActivityStatus.QCG_ACTIVITY_STATE_CANCELLED)){
			System.err.println("Job " + status.getActivityIdentifier() + " was cancelled");
		}
		
	}
	
}
