package pl.psnc.qcg.rm;

import java.io.File;
import java.io.FileInputStream;
import java.net.URL;
import java.util.Properties;

import javax.xml.bind.JAXBException;

import com.qcg.comp.sdk.ARES;
import com.qcg.core.sdk.security.anonymous.AnonymousAuthentication;

public class Cluster {
	public static final String DSP_ULR = "dsp.url";
	public static final String USE_WSA = "use.wsa";

	
	protected URL dspUrl;
	protected boolean useWSA;
	protected ARES ares;
	private String name;
	
	public Cluster(String propFile) throws JAXBException {
		name = new File(propFile).getName().split("\\.")[0];
		Properties prop =  new Properties();
		try {
			prop.load(new FileInputStream(propFile));
			
			dspUrl = new URL(prop.getProperty(DSP_ULR));
			useWSA = Boolean.parseBoolean(prop.getProperty(USE_WSA));
		} catch (Exception e) {
			throw new IllegalArgumentException("Unable to load cluster config file.", e);
		} 
		
		
		ares =  new ARES(dspUrl.getHost(), dspUrl.getPort(), new AnonymousAuthentication(), useWSA);
		
	}

	public URL getDspUrl() {
		return dspUrl;
	}

	public boolean isUseWSA() {
		return useWSA;
	}

	public ARES getAres() {
		return ares;
	}

	public String getName() {
		return name;
	}
		
	
}
