DROP TABLE reservations CASCADE;
DROP TABLE hosts CASCADE;

CREATE TABLE reservations
(
 uuid VARCHAR(64),
 cluster_name VARCHAR(64),
 drms_id VARCHAR(64),
 name VARCHAR(128),
 start_time TIMESTAMP,
 end_time TIMESTAMP,
 username VARCHAR(255),
 rtype VARCHAR(32) NOT NULL CHECK (rtype in ('user', 'system')),
 description VARCHAR(512)
 PRIMARY KEY (uuid)
);

CREATE TABLE hosts
(
 res_uuid VARCHAR(64),
 hostname VARCHAR(255) NOT NULL,
 reserved_cpus INT NOT NULL,
 total_cpus INT NOT NULL,
 used_cpus INT,
 FOREIGN KEY (res_uuid) REFERENCES reservations(uuid) ON DELETE CASCADE
);

INSERT INTO reservations VALUES ("urn:uuid:ea9b8a5f-059b-427a-92d1-39bc92f4b47d", "psnc", "usecase9#0", "qcg1234", CURRENT_TIMESTAMP, CURRENT_TIMESTAMP + interval 1 hour, "usecase9", "user");
INSERT INTO hosts VALUES ('urn:uuid:ea9b8a5f-059b-427a-92d1-39bc92f4b47d', 'node2.qoscosgrid.man.poznan.pl', 2, 4, 0);
INSERT INTO hosts VALUES ('urn:uuid:ea9b8a5f-059b-427a-92d1-39bc92f4b47d', 'node3.qoscosgrid.man.poznan.pl', 1, 4, 0);
