dnl
dnl Copyright 2006-2010 QCG Project Team
dnl
dnl Licensed under the Apache License, Version 2.0 (the "License");
dnl you may not use this file except in compliance with the License.
dnl You may obtain a copy of the License at
dnl
dnl     http://www.apache.org/licenses/LICENSE-2.0
dnl
dnl Unless required by applicable law or agreed to in writing, software
dnl distributed under the License is distributed on an "AS IS" BASIS,
dnl WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
dnl See the License for the specific language governing permissions and
dnl limitations under the License.
dnl

dnl SMC_CHECK_LIBACTIVEMQ_CPP([ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND]])

AC_DEFUN([SMC_CHECK_LIBACTIVEMQ_CPP],[ 
AC_ARG_WITH(libactivemq_cpp,
  AS_HELP_STRING([--with-libactivemq_cpp=PATH], [Prefix (e.g. /usr/local) where the libactivemq-cpp library is installed (optional). Default: /usr/local/lib]), \
  libactivemq_cpp_prefix="$withval/bin/", 
  libactivemq_cpp_prefix="")

  AC_MSG_CHECKING([for libactivemq_cpp])
  no_libactivemq_cpp=""

  LIBACTIVEMQ_CPP_CPPFLAGS=`$libactivemq_cpp_prefix""activemqcpp-config --includes`
  LIBACTIVEMQ_CPP_LIBS=`$libactivemq_cpp_prefix""activemqcpp-config --libs`" -Wl,-R"`$libactivemq_cpp_prefix""activemqcpp-config --prefix`/lib
 
  ac_save_CPPFLAGS="$CPPFLAGS"
  ac_save_LIBS="$LIBS"
  CPPFLAGS="$CPPFLAGS $LIBACTIVEMQ_CPP_CPPFLAGS"
  LIBS="$LIBACTIVEMQ_CPP_LIBS $LIBS"

  AC_LANG_PUSH(C++)
  AC_RUN_IFELSE([AC_LANG_SOURCE([[
#include <decaf/lang/Thread.h>
#include <decaf/lang/Runnable.h>
#include <decaf/util/concurrent/CountDownLatch.h>
#include <decaf/lang/Long.h>
#include <decaf/util/Date.h>
#include <activemq/core/ActiveMQConnectionFactory.h>
#include <activemq/util/Config.h>
#include <activemq/library/ActiveMQCPP.h>
#include <cms/Connection.h>
#include <cms/Session.h>
#include <cms/TextMessage.h>
#include <cms/BytesMessage.h>
#include <cms/MapMessage.h>
#include <cms/ExceptionListener.h>
#include <cms/MessageListener.h>
#include <stdlib.h>
#include <stdio.h>
#include <iostream>
#include <memory>

using namespace activemq;
using namespace activemq::core;
using namespace decaf;
using namespace decaf::lang;
using namespace decaf::util;
using namespace decaf::util::concurrent;
using namespace cms;
using namespace std;

int 
main()
{
   try
   {
	activemq::library::ActiveMQCPP::initializeLibrary();
	activemq::library::ActiveMQCPP::shutdownLibrary();
   }
   catch(CMSException& e)
   {
	e.printStackTrace();
        return 1;
   }
   return 0;  
}
]])],[],[no_libactivemq_cpp=yes],[echo $ac_n "cross compiling; assumed OK... $ac_c"])
  AC_LANG_POP(C++)

  CPPFLAGS="$ac_save_CPPFLAGS"
  LIBS="$ac_save_LIBS"

  if test "x$no_libactivemq_cpp" = x ; then
    AC_MSG_RESULT(yes)
    AC_SUBST(LIBACTIVEMQ_CPP_CPPFLAGS)
    AC_SUBST(LIBACTIVEMQ_CPP_LIBS)
    ifelse([$1], , :, [$1])
  else
    AC_MSG_RESULT(no)
    ifelse([$2], , :, [$2])
  fi

])
