dnl $Id: qcg-core.m4 2734 2009-09-21 21:17:04Z mmamonski $

dnl
dnl Copyright 2010 QCG Project Team
dnl
dnl Licensed under the Apache License, Version 2.0 (the "License");
dnl you may not use this file except in compliance with the License.
dnl You may obtain a copy of the License at
dnl
dnl     http://www.apache.org/licenses/LICENSE-2.0
dnl
dnl Unless required by applicable law or agreed to in writing, software
dnl distributed under the License is distributed on an "AS IS" BASIS,
dnl WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
dnl See the License for the specific language governing permissions and
dnl limitations under the License.
dnl

dnl SMC_CHECK_RSYNC([ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND]])

AC_DEFUN([SMC_CHECK_RSYNC],[ 
AC_ARG_WITH(rsync,
  AS_HELP_STRING([--with-rsync=PATH], [Prefix (e.g. /usr/local) where the librsync library (http://librsync.sourceforge.net/) is installed (optional).]),
  rsync_prefix="$withval", 
  rsync_prefix="/usr")
  
  AC_MSG_CHECKING([for librsync])
  no_rsync=""

  if test "x$rsync_prefix" = xno ; then
	AC_MSG_RESULT(disabled)
    	ifelse([$2], , :, [$2])
  else

    RSYNC_CPPFLAGS="-I$rsync_prefix/include "
    RSYNC_LIBS="-L$rsync_prefix/lib -lrsync "

    ac_save_CPPFLAGS="$CPPFLAGS"
    ac_save_LIBS="$LIBS"
    CPPFLAGS="$CPPFLAGS $RSYNC_CPPFLAGS"
    LIBS="$RSYNC_LIBS $LIBS"
  
    AC_CHECK_HEADER([librsync.h],[have_librsync="yes"],[no_rsync="yes"])
    AC_SEARCH_LIBS([rs_loadsig_begin],[rsync],[],[no_rsync="yes"])
  
    CPPFLAGS="$ac_save_CPPFLAGS"
    LIBS="$ac_save_LIBS"

    if test "x$no_rsync" = x ; then
      AC_MSG_RESULT(yes)
      AC_SUBST(RSYNC_CPPFLAGS)
      AC_SUBST(RSYNC_LIBS)
      ifelse([$1], , :, [$1])
    else
      AC_MSG_RESULT(no)
      ifelse([$2], , :, [$2])
    fi
  fi

])
