dnl $Id: qcg-core.m4 2734 2009-09-21 21:17:04Z mmamonski $

dnl
dnl Copyright 2006-2009 QCG Project Team
dnl
dnl Licensed under the Apache License, Version 2.0 (the "License");
dnl you may not use this file except in compliance with the License.
dnl You may obtain a copy of the License at
dnl
dnl     http://www.apache.org/licenses/LICENSE-2.0
dnl
dnl Unless required by applicable law or agreed to in writing, software
dnl distributed under the License is distributed on an "AS IS" BASIS,
dnl WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
dnl See the License for the specific language governing permissions and
dnl limitations under the License.
dnl

dnl SMC_CHECK_S3([ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND]])

AC_DEFUN([SMC_CHECK_S3],[ 
AC_ARG_WITH(s3,
  AS_HELP_STRING([--with-s3=PATH], [Prefix (e.g. /usr/local) where the S3 library is installed (optional). Default: /usr]),
  s3_prefix="$withval", 
  s3_prefix="/usr")

  AC_MSG_CHECKING([for libs3])
  no_s3=""

  S3_CPPFLAGS="-I$s3_prefix/include "
  S3_LIBS="-L$s3_prefix/lib -ls3 "

  ac_save_CPPFLAGS="$CPPFLAGS"
  ac_save_LIBS="$LIBS"
  CPPFLAGS="$CPPFLAGS $S3_CPPFLAGS"
  LIBS="$S3_LIBS $LIBS"
  
  AC_RUN_IFELSE([AC_LANG_SOURCE([[

#include <libs3.h>

int 
main()
{
  if (S3_initialize("QCG Computing", S3_INIT_ALL) == S3StatusOK)
    return 0;
  else
    return 1;
}
]])],[],[no_s3=yes],[echo $ac_n "cross compiling; assumed OK... $ac_c"])
  
  CPPFLAGS="$ac_save_CPPFLAGS"
  LIBS="$ac_save_LIBS"

  if test "x$no_s3" = x ; then
    AC_MSG_RESULT(yes)
    AC_SUBST(S3_CPPFLAGS)
    AC_SUBST(S3_LIBS)
    ifelse([$1], , :, [$1])
  else
    AC_MSG_RESULT(no)
    ifelse([$2], , :, [$2])
  fi

])
