/* $Id: common.c 2 2009-10-05 10:09:52Z mamonski $ */

/*
 * Copyright 2006-2009 QCG Project Team
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <qcg-core/sm.h>
#include <qcg-core/logger.h>

#include <common/common.h>
#include <common/python_module.h>
#include <extensions_internal.h>
#include <include/extensions.h>

sm_status_ret_code_t
smc_common_setup(void)
{
	SM_DEBUG_ENTER();

	smc_python_setup();
	smc_extensions_setup();

	return SM_OK;
}

void
smc_common_cleanup(void)
{
	SM_DEBUG_ENTER();

	smc_extensions_cleanup();
}
