/* $Id: staging_module.h 2 2009-10-05 10:09:52Z mamonski $ */

/*
 * Copyright 2006-2009 QCG Project Team
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef __SMC_STAGING_MODULE_H
#define __SMC_STAGING_MODULE_H

#include <sys/types.h>
#include <qcg-core/value.h>
#include <qcg-core/modules/modules.h>

/* These values are used in staging.c */
typedef enum {
	STAGING_OK = 0,
	STAGING_INTERNAL_FAULT = 1,
	STAGING_NOT_AUTHORIZED_FAULT = 1000,
	STAGING_DELETE_ON_TERMINATION_FAULT = 1001,
	STAGING_FILE_NOT_FOUND_FAULT = 1002,
	STAGING_LOCAL_STAGING_FAULT = 1003,
	STAGING_REMOTE_STAGING_FAULT = 1004,
	STAGING_UNSUPPORTED_PROTOCOL_FAULT = 1005
} staging_ret_code_t;

typedef sm_value_t *(*staging_stage_in_function)(sm_module_t this, _jsdl__DataStaging *ds, size_t size, const char *working_dir);
typedef sm_value_t *(*staging_stage_out_function)(sm_module_t this, _jsdl__DataStaging *ds, size_t size, const char *working_dir);

typedef struct staging_module_s {
        struct sm_module_s header;

        staging_stage_in_function stage_in;
        staging_stage_out_function stage_out;
} *staging_module_t;

#define STAGING_MODULE			struct staging_module_s __module_entry__
#define STAGING_MODULE_ENTRY_SIZE	sizeof(struct staging_module_s)

#define STAGING_MODULE_API		SM_BIT(SM_API_CUSTOM + 2)

#endif /* __SMC_STAGING_MODULE_H */
