/* $Id: ardl.h 2 2009-10-05 10:09:52Z mamonski $ */

/*
 *  Copyright 2006-2009 QCG Project Team
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

#ifndef __SMC_ARDL_H
#define __SMC_ARDL_H

#include <stdbool.h>

#include <qcg-core/sm.h>
#include <qcg-core/xmalloc.h>

#include <common.h>
#include <stub/qcgcompStub.h>

sm_status_ret_code_t smc_ardl_setup(void);
void smc_ardl_cleanup(void);

sm_ret_code_t smc_ardl_handle_filters(const char *ardl_str, const char **out, smc_strdup_function func, void *ctxt);

const char *smc_ardl_get_username(_ardl__ReservationDefinition *ardl);
sm_status_ret_code_t smc_ardl_set_username(_ardl__ReservationDefinition *ardl, const char *username, smc_malloc_function malloc_func, smc_strdup_function strdup_func, void *ctxt);

char *smc_ardl_str(_ardl__ReservationDefinition *ardl, smc_strdup_function func, void *ctxt);
sm_alloc_tracked_t smc_ardl_from_str(const char *ardl_str, _ardl__ReservationDefinition *ardl);

#endif /* __SMC_ARDL_H */
