/* $Id: jsdl.h 32 2009-12-14 15:43:29Z mamonski $ */

/*
 * Copyright 2006-2009 QCG Project Team
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef __SMC_JSDL_H
#define __SMC_JSDL_H

#include <stdbool.h>

#include <qcg-core/sm.h>
#include <qcg-core/xmalloc.h>

#include <common.h>
#include <stub/qcgcompStub.h>

sm_status_ret_code_t smc_jsdl_setup(void);
void smc_jsdl_cleanup(void);

sm_ret_code_t smc_jsdl_handle_filters(const char *jsdl_str, const char **out, smc_strdup_function func, void *ctxt);

char *smc_jsdl_str(_jsdl__JobDefinition *jsdl, smc_strdup_function func, void *ctxt);
sm_alloc_tracked_t smc_jsdl_from_str(const char *jsdl_str, _jsdl__JobDefinition *jsdl);

const char *smc_jsdl_get_username(_jsdl__JobDefinition *jsdl);
const char *smc_jsdl_get_working_dir(_jsdl__JobDefinition *jsdl, SM_BOOL create);
bool smc_jsdl_has_application(_jsdl__JobDefinition *jsdl);

bool smc_jsdl_stage_in_requested(_jsdl__JobDefinition *jsdl);
bool smc_jsdl_stage_out_requested(_jsdl__JobDefinition *jsdl);

#endif /* __SMC_JSDL_H */
