#ifndef CLIENT_H_
#define CLIENT_H_

#include <netinet/in.h>

enum client_status {Ok, Fail, Blocked};

struct client_context_s {

	int socket;
	int remote;

	char *buffer;
	int len;
	int size;

	char *remote_buffer;
	int remote_len;
	int remote_size;

	char *domain;

	struct sockaddr_in dst;

	void (*process)(struct client_context_s *context);
	void (*fail)(struct client_context_s *context);

	struct client_context_s *next;

	enum client_status status;

	int remote_events;

	struct pollfd *fd,*remote_fd;

	smc_socks_config_t config;
};
typedef struct client_context_s* client_context_t;

client_context_t create_client_context(int socket,  smc_socks_config_t config, struct sockaddr* addr, socklen_t addr_len);
void release_client_context(client_context_t client);

#endif /* CLIENT_H_ */
