#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
#include "attachment.h"
#include "stub/rsyncstructsStub.h"
#include "interface.h"
#include <qcg-core/xmalloc.h>
#include <qcg-core/modules/general_module.h>
#include <qcg-core/logger.h>

SM_INTERNAL_GENERAL_MODULE = {
        .header = {
                .name = "rsync-attachment"
        }
};

int
unpack_delta(rsync_transport_t transport,Delta *d)
{
	struct soap_multipart *attachment;

	SM_DEBUG_ENTER();

	for (attachment = RSYNC_GET_SOAP(transport)->mime.list; attachment; attachment = attachment->next)
		if(sm_strcmp(attachment->id,"delta")==0 || sm_strcmp(attachment->id,"<delta>")==0) {
			d->length=attachment->size;
			d->data=attachment->ptr;
			return SM_DEBUG_LEAVE_INT(SM_OK);
		}

	return SM_DEBUG_LEAVE_INT(SM_FAULT);
}
