/* $Id: qcg_compd.c 43 2009-12-27 19:21:24Z mamonski $ */

/*
 * Copyright 2006-2009 QCG Project Team
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <qcg-core/sm.h>
#include <qcg-core/service.h>
#include <qcg-core/modules/modules.h>

#include <xmlstructs/xmlstructs.h>

#include <common/common.h>
#include <include/submission_module.h>
#include <include/reservation_module.h>
#include <include/staging_module.h>
#include <include/namespaces.h>

#define QCG_COMPD_DEFAULT_CONFIG_FILE    QCG_COMP_DIR_SYSCONF "/qcg-compd.xml"
#define QCG_COMP_CONFIG_SCHEMA_FILE      QCG_COMP_DIR_XSD "/qcg-comp.xsd"

__SM_ID("$Id: qcg_compd.c 43 2009-12-27 19:21:24Z mamonski $");

int
main(int argc, char *argv[])
{
	sm_module_api_t api;
	sm_module_mode_t mode = SM_MODULE_MODE_ALL;
	int ret;

	api = SM_API_ALL;

	/*api &= ~SUBMISSION_MODULE_API*/
	api &= ~RESERVATION_MODULE_API;

	smc_common_setup();

	ret = sm_service(argc, argv, QCG_COMPD_DEFAULT_CONFIG_FILE, QCG_COMP_CONFIG_SCHEMA_FILE, SMC_NAMESPACE_CONFIG, VERSION, &api, &mode);

	smc_common_cleanup();

	return ret;
}
